#-------------------------------------#
#        BigO's Terminator  v1.0      #
#-------------------------------------#


local TLandUnit = import('/lua/modules/terranunits.lua').TLandUnit
local TIFArtilleryWeapon = import('/lua/modules/terranweapons.lua').TIFArtilleryWeapon
local EmitFx = import('/lua/modules/entity.lua').Entity 
local Wep = import('/lua/modules/weapon.lua')
local me = import('/lua/modules/unit.lua')

 


UEL0402 = Class(TLandUnit) {
    Weapons = {
    
    
        NukeShell = Class(TIFArtilleryWeapon) {
        
             
        FxMuzzleFlashScale = 8,     ## INCREASE Muzzle Flash by 8 times  ##
        
          
    #===================================================================================================#  
 
						#########################
						#                       #
						#    On Weapon Fired    #
						#                       #
						#########################             
        
          
          OnWeaponFired = function(self)
          
                       
               #--------[Testing Purposes Only]---------#         
               #  LOG('------- Shot ' .. me.TimesFired) #                    
               #  LOG('Fire')                           #
               #----------------------------------------#
               
                 
	       #-------------------------------------------#
	       #    Simulates having a Muzzle Salvo Size   #  
	       #-------------------------------------------#
	     
		SimulateSalvoSizeThread = function(self)
			
			
			#-------------------------------------------
			# Wait 5 Seconds to allow for 10-11 shots, 
			# THEN reset both ROF and the Shot Counter
			#-------------------------------------------
			
			   WaitSeconds(5)

			       Wep:ChangeRateOfFire(0.0165)		
			
			       me.TimesFired = 0
			
			
			#-----------------------------------------------------
			# Wait 2 Seconds, then allow this thread to run again 
			# whenever it's ready.
			#-----------------------------------------------------
			
			   WaitSeconds(2)		

			       me.Firing = nil 		
			
                               if me.HellFireMode == 1 then Wep:ChangeRateOfFire(2) end
		end
           
           
               
      #===================================================================================================#
      #        -----------------            Main Firing Mechanism            ---------------------        #
      #===================================================================================================#
		#----------------------------------------------------------
		#  If in HellFire mode, run SimulateSalvoSizeThread only if
		#  if it is the first shot in the "burst"
		#---------------------------------------------------------- 
			
                
		if me.HellFireMode == 1 then		
		           
	              me.TimesFired = me.TimesFired + 1

		      if me.TimesFired == 1 then			

				me.Firing = me:ForkThread(SimulateSalvoSizeThread)	
				
                        end

		end     
       
      #===================================================================================================#       
      #===================================================================================================#
      
          end,
       }, 

    },
                                            #===============================#
                                            #=== END OF WEAPON FUNCTIONS ===#
                                            #===============================#
                                            
    #=======================================================================================================#
    
                                            #===============================#
                                            #=== START OF UNIT FUNCTIONS ===#
                                            #===============================#
 
						#########################
						#                       #
						#       On Create       #
						#                       #
						#########################    
    
    OnCreate = function(self, spec)
        TLandUnit.OnCreate(self, spec)

	#--------------------
	#  GLOBAL VARIABLES
	#--------------------
	
        me = self
        
        me.TimesFired = 0
        
        me.HellFireMode = 0   
    
    end,
    
    
  #===========================================================================================================#
 
 
						#########################
						#                       #
						#    HellFire Toggle    #
						#                       #
						#########################
						
						


#---------------------
#  On Button Pressed
#---------------------
    OnScriptBitSet = function(self, bit)   
        TLandUnit.OnScriptBitSet(self, bit)              
      
      
        if bit == 1 then 
                   
            EmitFx = CreateAttachedEmitter(self, 'AttachPoint', self:GetArmy(), '/mods/bigo_mobilenukearty/hook/fx/aeon_t1power_ambient_01_emit.bp'):ScaleEmitter(4)
            
                   
            #-------------------------------------------------
            # Create a global reference to weapon
                local gun = self:GetWeaponByLabel('NukeShell')       
                Wep = gun
            #-------------------------------------------------  
            
           
            me.HellFireMode = 1    
            
            self:ForkThread(self.HellFireToggleThread)
        
        end
        
    end,
    
#-----------------------
#  Change Weapon Stats
#-----------------------
    HellFireToggleThread = function(self)
    
         ------------
         -- Damage --          
         ------------
            Wep.DamageMod = 3000
            
         -------------------
         -- Damage Radius --
         -------------------
            Wep.DamageRadiusMod = 40     
         
         --------------------------
         -- Projectile Blueprint --
         --------------------------
            Wep:ChangeProjectileBlueprint('/mods/BigO_MobileNukeArty/hook/proj/HellFireShell/HellFireShell_proj.bp')
         
         -----------------------
         -- Firing Randomness --
         -----------------------
            Wep:SetFiringRandomness(1.5)           
         
         ------------------
         -- Rate of Fire --
         ------------------
            Wep:ChangeRateOfFire(2)
    
    end,    
    
    
  #==========================================================================================================#
    
						#########################
						#                       #
						#  Single  Nuke Toggle  #
						#                       #
						#########################
						
						


#---------------------
#  On Button Pressed
#---------------------
    OnScriptBitClear = function(self, bit)
        TLandUnit.OnScriptBitClear(self, bit)         
        
        if bit == 1 then                       
        
             self:ForkThread(self.SingleNukeToggleThread)   
             
        end
       
    end,    

    
#-----------------------
#  Change Weapon Stats
#-----------------------
    SingleNukeToggleThread = function(self)
    
          ## ---------------------------------------------------------------------------------
          ## This ensures that clicking the toggle buttton again wont interrupt HellFireMode  
          ## ---------------------------------------------------------------------------------
          
              while me.Firing do WaitSeconds(1) end
          
         ------------
         -- Damage --          
         ------------          
           Wep.DamageMod = 0
          
         -------------------
	 -- Damage Radius --
         -------------------
	   Wep.DamageRadiusMod = 0  
	  
	 --------------------------
         -- Projectile Blueprint --
         -------------------------- 
	   Wep:ChangeProjectileBlueprint('/mods/BigO_MobileNukeArty/hook/proj/SingleNukeShell/SingleNukeShell_proj.bp')
	  
	 -----------------------
	 -- Firing Randomness --
         -----------------------
	   Wep:SetFiringRandomness(0)	  
	 
         ------------------
	 -- Rate of Fire --
         ------------------
           Wep:ChangeRateOfFire(0.0165)
          
         ----------------------------
	 -- Turn Off HellFire Mode --
         ----------------------------
           me.HellFireMode = 0
           EmitFx:Destroy()
    end,
    
   
  #============================================================================================================#
    
}

TypeClass = UEL0402